<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EditaDocumentoVendaIdJSON StructType
 * @subpackage Structs
 */
class EditaDocumentoVendaIdJSON extends AbstractStructBase
{
    /**
     * The idVenda
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $idVenda;
    /**
     * The forceRefresh
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $forceRefresh;
    /**
     * Constructor method for EditaDocumentoVendaIdJSON
     * @uses EditaDocumentoVendaIdJSON::setIdVenda()
     * @uses EditaDocumentoVendaIdJSON::setForceRefresh()
     * @param string $idVenda
     * @param bool $forceRefresh
     */
    public function __construct($idVenda = null, $forceRefresh = null)
    {
        $this
            ->setIdVenda($idVenda)
            ->setForceRefresh($forceRefresh);
    }
    /**
     * Get idVenda value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdVenda()
    {
        return isset($this->idVenda) ? $this->idVenda : null;
    }
    /**
     * Set idVenda value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $idVenda
     * @return \StructType\EditaDocumentoVendaIdJSON
     */
    public function setIdVenda($idVenda = null)
    {
        // validation for constraint: string
        if (!is_null($idVenda) && !is_string($idVenda)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($idVenda)), __LINE__);
        }
        if (is_null($idVenda) || (is_array($idVenda) && empty($idVenda))) {
            unset($this->idVenda);
        } else {
            $this->idVenda = $idVenda;
        }
        return $this;
    }
    /**
     * Get forceRefresh value
     * @return bool|null
     */
    public function getForceRefresh()
    {
        return $this->forceRefresh;
    }
    /**
     * Set forceRefresh value
     * @param bool $forceRefresh
     * @return \StructType\EditaDocumentoVendaIdJSON
     */
    public function setForceRefresh($forceRefresh = null)
    {
        // validation for constraint: boolean
        if (!is_null($forceRefresh) && !is_bool($forceRefresh)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($forceRefresh)), __LINE__);
        }
        $this->forceRefresh = $forceRefresh;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EditaDocumentoVendaIdJSON
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
